/*
  pyAB_prj.c

*/
#include "simpletools.h"
#include "simpletext.h"
#include "fdserial.h"
#include "abdrive.h"
#include "ping.h"

static volatile int xbCog;
static volatile int speedLeft = 0;
static volatile int speedRight = 0;
static volatile int roamcmd;
static volatile int speedLeftOld = 0;
static volatile int speedRightOld = 0;

serial *xbee;

int XB_remote(void);
void ab_nav(void);
void global_Roam(void);

int main()
{
  // Add startup code here.

  char inBuff[40];
/*                     Rx  Tx mode BAUD */
  xbee = fdserial_open(7, 6, 0, 9600);
  pause(500);

  int roamcmdOld = roamcmd;
  int speedLold2 = speedLeft;
  int speedRold2 = speedRight;

  int key = -1, xbcmd = -1;

  while(1)
  {
    // Add main loop code here.
    xbcmd = XB_remote();
    if(xbcmd == 1) global_Roam();
    ab_nav();    
  }  
}

///////////////////////////////////////////////////////////////////////////////
/* XB remote control */
int XB_remote()
{
  char inBuff[40];
  int retval = 0;

if(fdserial_rxReady(xbee))
  {    
    readStr(xbee, inBuff, 40);
    //writeStr(xbee,"> ");
    if(!strcmp(inBuff,"onled"))
    {
      high(26);
      //writeStr(xbee,"logtime");
    }
    else if(!strcmp(inBuff,"offled"))
    {
      low(26);
      //writeStr(xbee,"logtime");
    }
    else if(!strcmp(inBuff,"gostop"))
    {
      speedLeft = 0;
      speedRight = 0;
    }
    else if(!strcmp(inBuff,"gofore"))
    {
      speedLeft = 32;
      speedRight = 32;
    }
    else if(!strcmp(inBuff,"goback"))
    {
      speedLeft = -32;
      speedRight = -32;
    }
    else if(!strcmp(inBuff,"goright"))
    {
      speedLeft = 16;
      speedRight = 0;
    }
    else if(!strcmp(inBuff,"goleft"))
    {
      speedLeft = 0;
      speedRight = 16;
    }
    else if(!strcmp(inBuff,"startroam"))
    {
      retval = 1;
    }
    else if(!strcmp(inBuff,"stoproam"))
    {
      retval = 2;
      speedLeft = 0;
      speedRight = 0;
    }
    else
    {
      writeLine(xbee,"Invalid Command!");
      retval = -1;
    }
  }
  return retval;   
}

///////////////////////////////////////////////////////////////////////////////
void ab_nav(void)
{
  if(speedLeftOld != speedLeft || speedRightOld != speedRight)
  {
    drive_speed(speedLeft, speedRight);
    speedLeftOld = speedLeft;
    speedRightOld = speedRight;
  } 
  pause(20);
}

///////////////////////////////////////////////////////////////////////////////

void global_Roam(void)
{
  int turn;
  roamcmd = 0;
  while(1)
  {
    if(XB_remote() == 2)
      return;
    else
    {
      speedLeft = 32;
      speedRight = 32;
      ab_nav();
      pause(100);
      while(ping_cm(5) >= 20)  // Ping is p5
      {
        pause(5);
        if(XB_remote() == 2) return;
      }
      if(XB_remote() == 2) return;

      turn = rand() % 2;
      if(turn == 1)

      {
        speedLeft = 16;
        speedRight = -16;
      }
      else
      {
        speedLeft = -16;
        speedRight = 16;
      }
      ab_nav();
      while(ping_cm(5) < 20);  // Ping is p5
      {
        pause(5);
        if(XB_remote() == 2) return;
      }
    }
  } 
}
